package com.bonus.system.basic.controller;

import com.bonus.common.core.utils.poi.ExcelUtil;
import com.bonus.common.core.web.controller.BaseController;
import com.bonus.common.core.web.domain.AjaxResult;
import com.bonus.common.core.web.page.TableDataInfo;
import com.bonus.common.log.annotation.Log;
import com.bonus.common.log.enums.BusinessType;
import com.bonus.common.security.annotation.RequiresPermissions;
import com.bonus.common.security.utils.SecurityUtils;
import com.bonus.system.api.domain.SysRole;
import com.bonus.system.basic.domain.SysUserRole;
import com.bonus.system.basic.service.ISysRoleService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;

/**
 * 角色信息
 * 
 * @author bonus
 */
@RestController
@RequestMapping("/role")
public class SysRoleController extends BaseController
{
    @Autowired
    private ISysRoleService roleService;

    @RequiresPermissions("system:role:list")
    @GetMapping("/list")
    @Log(title = "系统管理->角色管理->查询角色列表", businessType = BusinessType.QUERY)
    public TableDataInfo list(SysRole role) {
        try{
            startPage();
            List<SysRole> list = roleService.selectRoleList(role);
            return getDataTable(list);
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return  getDataTableError(new ArrayList<>());
    }


    @RequiresPermissions("system:role:export")
    @PostMapping("/export")
    @Log(title = "系统管理->角色管理->导出角色excel", businessType = BusinessType.EXPORT)
    public void export(HttpServletResponse response, SysRole role) {
        try{
            List<SysRole> list = roleService.selectRoleList(role);
            ExcelUtil<SysRole> util = new ExcelUtil<SysRole>(SysRole.class);
            util.exportExcel(response, list, "角色数据");
        }catch (Exception e){
            logger.error(e.toString(),e);
        }

    }

    /**
     * 根据角色编号获取详细信息
     */
    @RequiresPermissions("system:role:query")
    @GetMapping(value = "/{roleId}")
    public AjaxResult getInfo(@PathVariable Long roleId) {
        try{
            roleService.checkRoleDataScope(roleId);
            return success(roleService.selectRoleById(roleId));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");
    }

    /**
     * 新增角色
     */
    @RequiresPermissions("system:role:add")
    @PostMapping
    @Log(title = "系统管理->角色管理->新增角色", businessType = BusinessType.INSERT)
    public AjaxResult add(@Validated @RequestBody SysRole role) {
        try{
            if (!roleService.checkRoleNameUnique(role)) {
                return error("新增角色'" + role.getRoleName() + "'失败，角色名称已存在");
            } else if (!roleService.checkRoleKeyUnique(role)) {
                return error("新增角色'" + role.getRoleName() + "'失败，角色权限已存在");
            }
            role.setCreateBy(SecurityUtils.getUsername());
            return toAjax(roleService.insertRole(role));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");
    }

    /**
     * 修改保存角色
     */
    @RequiresPermissions("system:role:edit")
    @PutMapping
    @Log(title = "系统管理->角色管理->修改角色", businessType = BusinessType.UPDATE)
    public AjaxResult edit(@Validated @RequestBody SysRole role) {
        try{
            roleService.checkRoleAllowed(role);
            roleService.checkRoleDataScope(role.getRoleId());
            if (!roleService.checkRoleNameUnique(role)) {
                return error("修改角色'" + role.getRoleName() + "'失败，角色名称已存在");
            } else if (!roleService.checkRoleKeyUnique(role)) {
                return error("修改角色'" + role.getRoleName() + "'失败，角色权限已存在");
            }
            role.setUpdateBy(SecurityUtils.getUsername());
            return toAjax(roleService.updateRole(role));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");

    }

    /**
     * 修改保存数据权限
     */
    @RequiresPermissions("system:role:edit")
    @PutMapping("/dataScope")
    @Log(title = "系统管理->角色管理->修改权限", businessType = BusinessType.UPDATE)
    public AjaxResult dataScope(@RequestBody SysRole role) {
        try{
            roleService.checkRoleAllowed(role);
            roleService.checkRoleDataScope(role.getRoleId());
            return toAjax(roleService.authDataScope(role));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");
    }

    /**
     * 状态修改
     */
    @RequiresPermissions("system:role:edit")
    @PutMapping("/changeStatus")
    @Log(title = "系统管理->角色管理->修改角色状态", businessType = BusinessType.UPDATE)
    public AjaxResult changeStatus(@RequestBody SysRole role) {
        try{
            roleService.checkRoleAllowed(role);
            roleService.checkRoleDataScope(role.getRoleId());
            role.setUpdateBy(SecurityUtils.getUsername());
            return toAjax(roleService.updateRoleStatus(role));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");


    }

    /**
     * 删除角色
     */
    @RequiresPermissions("system:role:remove")
    @DeleteMapping("/{roleIds}")
    @Log(title = "系统管理->角色管理->删除角色信息", businessType = BusinessType.DELETE)
    public AjaxResult remove(@PathVariable Long[] roleIds) {
        try{
            return toAjax(roleService.deleteRoleByIds(roleIds));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");


    }

    /**
     * 获取角色选择框列表
     */
    @RequiresPermissions("system:role:query")
    @GetMapping("/optionselect")
    public AjaxResult optionselect() {
        try{
            return success(roleService.selectRoleAll());
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");

    }

    /**
     * 取消授权用户
     */
    @RequiresPermissions("system:role:edit")
    @PutMapping("/authUser/cancel")
    @Log(title = "系统管理->角色管理->分配用户->取消授权用户", businessType = BusinessType.UPDATE)
    public AjaxResult cancelAuthUser(@RequestBody SysUserRole userRole) {
        try{
            return toAjax(roleService.deleteAuthUser(userRole));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");

    }

    /**
     * 批量取消授权用户
     */
    @RequiresPermissions("system:role:edit")
    @PutMapping("/authUser/cancelAll")
    @Log(title = "系统管理->角色管理->分配用户->批量取消授权用户", businessType = BusinessType.GRANT)
    public AjaxResult cancelAuthUserAll(Long roleId, Long[] userIds) {
        try{
            return toAjax(roleService.deleteAuthUsers(roleId, userIds));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");

    }

    /**
     * 批量选择用户授权
     */
    @RequiresPermissions("system:role:edit")
    @PutMapping("/authUser/selectAll")
    @Log(title = "系统管理->角色管理->分配用户->批量授权用户", businessType = BusinessType.GRANT)
    public AjaxResult selectAuthUserAll(Long roleId, Long[] userIds) {
        try{
            roleService.checkRoleDataScope(roleId);
            return toAjax(roleService.insertAuthUsers(roleId, userIds));
        }catch (Exception e){
            logger.error(e.toString(),e);
        }
        return error("系统异常,请联系管理员");
    }

}
